unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Grids, DBGrids, ExtCtrls, Db, FoxDSet, ComCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    OpenDialog1: TOpenDialog;
    FoxDSet1: TFoxDSet;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    DBImage1: TDBImage;
    Button2: TButton;
    OpenDialog2: TOpenDialog;
    TabSheet2: TTabSheet;
    Button1: TButton;
    FoxDSet2: TFoxDSet;
    DataSource2: TDataSource;
    DBGrid2: TDBGrid;
    Button3: TButton;
    DBNavigator2: TDBNavigator;
    TabSheet3: TTabSheet;
    DBGrid3: TDBGrid;
    DBGrid4: TDBGrid;
    DBGrid5: TDBGrid;
    FoxDSet3: TFoxDSet;
    DataSource3: TDataSource;
    FoxDSet4: TFoxDSet;
    DataSource4: TDataSource;
    FoxDSet5: TFoxDSet;
    DataSource5: TDataSource;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button4: TButton;
    FoxDSet3CHEQUE: TStringField;
    FoxDSet3DATE: TDateTimeField;
    FoxDSet3SUM: TCurrencyField;
    FoxDSet3Taxe: TCurrencyField;
    FoxDSet3member: TStringField;
    TabSheet5: TTabSheet;
    Button5: TButton;
    Label5: TLabel;
    Edit1: TEdit;
    Button6: TButton;
    DBNavigator3: TDBNavigator;
    Label6: TLabel;
    Label7: TLabel;
    TabSheet6: TTabSheet;
    FoxDSet6: TFoxDSet;
    FoxDSet7: TFoxDSet;
    DataSource6: TDataSource;
    DataSource7: TDataSource;
    DBGrid7: TDBGrid;
    DBGrid8: TDBGrid;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    FoxDSet8: TFoxDSet;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FoxDSet3CalcFields(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FoxDSet6UserEncode(buffer: Pointer; count: Integer;
      Mode: TBlobStreamMode);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MyDataSet: TFoxDSet;
  MyDataSource: TDataSource;
  MyDBGrid: TDBGrid;

implementation

{$R *.DFM}

   {Open Page}
procedure TForm1.Button1Click(Sender: TObject);
begin
if opendialog1.Execute then
        begin
        FoxDSet2.Active := False;
        FoxDSet2.TableName := opendialog1.FileName;
        FoxDSet2.Active := True;
        Label7.Caption := IntToStr(FoxDSet2.RecordCount);
        Label4.Caption := IntToStr(FoxDSet2.SizeDataFile);
        end;
end;

   {Simple Page}
procedure TForm1.Button3Click(Sender: TObject);
begin
FoxDSet1.Active := not FoxDSet1.Active;
Label2.Caption := IntToStr(FoxDSet1.SizeDataFile);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if opendialog2.Execute then
        begin
        DBImage1.Picture.LoadFromFile(opendialog2.FileName);
        DBImage1.Field.Assign(DBImage1.Picture); // Post
        Label2.Caption := IntToStr(FoxDSet1.SizeDataFile);
        end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     FoxDSet1.Pack;
     Label2.Caption := IntToStr(FoxDSet1.SizeDataFile);
end;

procedure TForm1.FoxDSet3CalcFields(DataSet: TDataSet);
begin
DataSet.Fields.FieldByName('TAXE').Value := DataSet.Fields.FieldByName('SUM').Value * 1.02;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyDataSet:=nil;
  MyDataSource:=nil;
  MyDBGrid:=nil;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MyDBGrid.free;
  MyDataSource.free;
  MyDataSet.free;
end;

procedure TForm1.Button5Click(Sender: TObject);
var i:integer;
begin
  MyDBGrid.free;
  MyDataSource.free;
  MyDataSet.free;
  {Create objects}
  MyDataSet:= TFoxDSet.Create(self);
  MyDataSource:= TDataSource.Create(self);
  MyDBGrid:= TDBGrid.Create(self);
  MyDBGrid.Visible:=False;
  MyDBGrid.Parent:=TabSheet5;
  MyDBGrid.DataSource:=MyDataSource;
  MyDataSource.DataSet:=MyDataSet;
  {Create table}
  MyDataSet.TableName:='MyTab';

  MyDataSet.TableType:=Fox30;
  MyDataSet.FieldDefs.Clear;
    with MyDataSet.FieldDefs.AddFieldDef do begin
    Name := 'Name';
    DataType := ftString;
    Size := 15;
    end;
    with MyDataSet.FieldDefs.AddFieldDef do begin
    Name := 'Tax';
    DataType := ftCurrency;
    end;
    with MyDataSet.FieldDefs.AddFieldDef do begin
    Name := 'Number';
    DataType := ftString;
    Size := 10;
    end;
  MyDataSet.CreateTable;
  MyDataSet.Active:=True;
  //Fill table records
  Randomize;
  for i:=1 to 100000 do begin
  MyDataSet.Append;
  MyDataSet.Fields[0].Value:=chr(Random(25)+65)+chr(Random(25)+65)+chr(Random(25)+65)+chr(Random(25)+65)+chr(Random(25)+65);
  MyDataSet.Fields[1].Value:=Random * 10;
  MyDataSet.Fields[2].Value:=chr(Random(9)+48)+chr(Random(9)+48)+chr(Random(9)+48)+chr(Random(9)+48)+chr(Random(9)+48)+chr(Random(9)+48);
  MyDataSet.Post;
  Label5.Caption:=inttostr(i);
  Label5.Repaint;
                    end;

  Button5.Enabled:=false;
  DBNavigator3.DataSource:=MyDataSource;
  MyDBGrid.Visible:=True;
  MyDataSet.Active:=True;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
if assigned(MyDataSet) then begin
MyDataSet.Filtered := False;
MyDataSet.Filter := Edit1.Text;
MyDataSet.Filtered := True;
end;
end;

{Encode}
procedure TForm1.FoxDSet6UserEncode(buffer: Pointer; count: Integer;
  Mode: TBlobStreamMode);
  var b:PChar;
  i:integer;
begin
b:=buffer;
if mode=bmRead then
        if not ((b[0] = chr(0))or(b[0]= chr(32))) then
        begin
        for i:=0 to count-1 do b[i]:=chr(ord(b[i]) xor 47);
        end;
if mode=bmWrite then
        begin
        for i:=0 to count-1 do b[i]:=chr(ord(b[i]) xor 47);
        end;

end;

end.
